// +FHDR------------------------------------------------------------
//                 Copyright (c) 2022 SmartLogic.
//                       ALL RIGHTS RESERVED
// -----------------------------------------------------------------
// Filename      : case20_ape3_task.s.c
// Author        : 
// Created On    : 2023-01-05
// Last Modified :
// -----------------------------------------------------------------
// Description:
//
//
// -FHDR------------------------------------------------------------
#include "ucp_utility.h"
#include "ucp_tick.h"
#include "ucp_printf.h"
#include "phy_para.h"
#include "osp_msg.h"
#include "ucp_testcase.h"
#include "msg_transfer_layer.h"
#include "ucp_port.h"
#include "ape_mtimer.h"
#include "osp_task.h"
#include "osp_timer.h"

/***************************************************************/
/*                  定时时任务相关打点                                  */
static uint32_t g_u32_case1_ape3_timer1_cnt     = 0; // 32 0xB7E00680
static uint32_t g_u32_case1_ape3_timer2_cnt     = 0; // 33 0xB7E00684
static uint32_t g_u32_case1_ape3_timer3_cnt     = 0; // 34 0xB7E00688

/* 定时点任务 */
void ape3_timer1_task(void)
{
    uint32_t ape_id = get_core_id();
    debug_write(DBG_DDR_COMMON_IDX(ape_id, 32), ++g_u32_case1_ape3_timer1_cnt);

    return;
}

void ape3_timer2_task(void)
{
    uint32_t ape_id = get_core_id();
    debug_write(DBG_DDR_COMMON_IDX(ape_id, 33), ++g_u32_case1_ape3_timer2_cnt);

    return ;
}

void ape3_timer3_task(void)
{
    uint32_t ape_id = get_core_id();
    debug_write(DBG_DDR_COMMON_IDX(ape_id, 34), ++g_u32_case1_ape3_timer3_cnt);

    return ;
}

/*************************************************************************/
/* 收到消息后创建任务 */
void ape3_event_task(uint32_t addr, uint32_t size)
{
    uint32_t ape_id = get_core_id();
    debug_write(DBG_DDR_COMMON_IDX(ape_id, 29), 0x01010101);

    osp_task_info_ex ape3_task_timer1 = {43, (int8_t*)"ape3_task_timer1", 43, 2048, OSP_TIMER_TYPE, 0, 0x3ff, 3,   NULL, (OSP_TASKENTRY_FUNC)ape3_timer1_task};
    osp_task_info_ex ape3_task_timer2 = {44, (int8_t*)"ape3_task_timer2", 44, 2048, OSP_TIMER_TYPE, 0, 0x3ff, 190, NULL, (OSP_TASKENTRY_FUNC)ape3_timer2_task};
    osp_task_info_ex ape3_task_timer3 = {45, (int8_t*)"ape3_task_timer3", 45, 2048, OSP_TIMER_TYPE, 0, 0x3ff, 300, NULL, (OSP_TASKENTRY_FUNC)ape3_timer3_task};

    osp_task_create(&ape3_task_timer1);
    osp_task_create(&ape3_task_timer2);
    osp_task_create(&ape3_task_timer3);

    osp_timer_sync(NR_SCS_30K);

    debug_write(DBG_DDR_COMMON_IDX(ape_id, 29), 0x03030303);
    return;
}

/* 收到消息后删除任务 */
void ape3_event_task1(uint32_t addr, uint32_t size)
{
    osp_del_task(43, 1);
    osp_del_task(44, 1);
    osp_del_task(45, 1);
    osp_timer_unsync(NR_SCS_30K);

    return ;
}

