/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: cpri_test_case80.c
*  Create Date: 24/2/20
*  Description: 
*  Change History: 
*      <author>      <time>      <version>   <desc>
*    1. cheng.wan    24/02/20      2.0       refactor
**********************************************************************************************************************/
/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include "typedef.h"
#include "ucp_utility.h"
#include "ucp_printf.h"
#include "cpri_timer.h"
#include "cpri_driver.h"
#include "rfm1_drv.h"
#include "cpri_test.h"
#include "cpri_csu.h"
#include "cpri_test_case.h"
#include "cpri_csu_8nr_8lte.h"


//* --------------------------------------------------- <DEF&DEC> --------------------------------------------------- */




/* -------------------------------------------------- <FUNC DEF> --------------------------------------------------- */
/**********************************************************************************************************************
*  function: axc_data_init
*  description: 
*  input : none
*  output: none
*  return: none
*  others: none
**********************************************************************************************************************/
extern uint32_t nr_lte_comp[7680];
extern uint32_t nr_ant0_1[122880];
extern uint32_t nr_ant2_3[122880];
extern uint32_t nr_ant4_5[122880];
extern uint32_t nr_ant6_7[122880];
extern uint32_t lte_ant0_7[122880];

void axc_data_init()
{
    uint32_t    data_id   = 0;
    uint32_t    slot_type = 0;
    uint32_t    dst_addr = 0;
    uint32_t    src_addr = 0;
    uint32_t    data_len = 0;
    uint16_t    byte_num_per_bf = 0;
    uint32_t	word_num_per_bf = 0;
    uint32_t    bf_num_per_slot = (LONGCP_BF_CNT + SHORTCP_BF_CNT * 13) * 2;
    uint32_t    word_idx_in_slot= 0;


    /* compress factor */
    for(slot_type = 0; slot_type <= 1; slot_type++)
    {
        byte_num_per_bf = 8;
        word_num_per_bf = byte_num_per_bf >> 2;
        data_len = byte_num_per_bf * bf_num_per_slot;

        if(slot_type == 0)
        {
            src_addr = (uint32_t)(&nr_lte_comp[0]);		
            dst_addr = CPRI_8NR8LTE_TX_SLOT_EVEN_COMPRESS_ADDR;
        }
        else
        {		
            src_addr = (uint32_t)(&nr_lte_comp[0]);	            	
            dst_addr = CPRI_8NR8LTE_TX_SLOT_ODD_COMPRESS_ADDR;
        }

        memcpy_ucp((void*)dst_addr, (void*)src_addr, data_len);
    }


    /* iq data */
    for(data_id = 1; data_id < 6; data_id++)
    {
        byte_num_per_bf = 64*2;
        word_num_per_bf = byte_num_per_bf >> 2;

        for(slot_type = 0; slot_type <= 1; slot_type++)
        {
            word_idx_in_slot = 0;
            data_len = byte_num_per_bf * bf_num_per_slot;

            if(slot_type == 0)
            {
                if(data_id == 1)
                {
                    src_addr = (uint32_t)(&nr_ant0_1[0]);
                    dst_addr = CPRI_8NR8LTE_TX_SLOT_EVEN_NR_AXC1_2_ADDR;

                }else if(data_id == 2)
                {
                    src_addr = (uint32_t)(&nr_ant2_3[0]);                    
                    dst_addr = CPRI_8NR8LTE_TX_SLOT_EVEN_NR_AXC3_4_ADDR;
                }else if(data_id == 3)
                {
                    src_addr = (uint32_t)(&nr_ant4_5[0]);
                    dst_addr = CPRI_8NR8LTE_TX_SLOT_EVEN_NR_AXC5_6_ADDR;
                }else if(data_id == 4)
                {
                    src_addr = (uint32_t)(&nr_ant6_7[0]);
                    dst_addr = CPRI_8NR8LTE_TX_SLOT_EVEN_NR_AXC7_8_ADDR;
                }else if(data_id == 5)
                {
                    src_addr = (uint32_t)(&lte_ant0_7[0]);
                    dst_addr = CPRI_8NR8LTE_TX_SLOT_EVEN_LTE_AXC1_8_ADDR;
                }
            }else if(slot_type == 1)
            {
                if(data_id == 1)
                {
                    src_addr = (uint32_t)(&nr_ant0_1[0]);                    
                    dst_addr = CPRI_8NR8LTE_TX_SLOT_ODD_NR_AXC1_2_ADDR;
                }else if(data_id == 2)
                {
                    src_addr = (uint32_t)(&nr_ant2_3[0]);                     
                    dst_addr = CPRI_8NR8LTE_TX_SLOT_ODD_NR_AXC3_4_ADDR;
                }else if(data_id == 3)
                {
                    src_addr = (uint32_t)(&nr_ant4_5[0]);                    
                    dst_addr = CPRI_8NR8LTE_TX_SLOT_ODD_NR_AXC5_6_ADDR;
                }else if(data_id == 4)
                {
                    src_addr = (uint32_t)(&nr_ant6_7[0]);                    
                    dst_addr = CPRI_8NR8LTE_TX_SLOT_ODD_NR_AXC7_8_ADDR;
                }else if(data_id == 5)
                {
                    src_addr = (uint32_t)(&lte_ant0_7[0]);                    
                    dst_addr = CPRI_8NR8LTE_TX_SLOT_ODD_LTE_AXC1_8_ADDR;
                }
            }

            memcpy_ucp((void*)dst_addr, (void*)src_addr, data_len);
        }
    }
}


/**********************************************************************************************************************
*  function: axc_data_check
*  description: 
*  input : none
*  output: none
*  return: none
*  others: none
**********************************************************************************************************************/
void axc_data_check(uint32_t slot_idx)
{
    return;
}


/**********************************************************************************************************************
*  function: fh_data_init
*  description: 
*  input : none
*  output: none
*  return: none
*  others: none
**********************************************************************************************************************/
extern  uint32_t  gCpriTestMode;

int32_t fh_data_init(void)
{
    gCpriTestMode = CPRI_TEST_MODE;
    debug_write((DBG_DDR_IDX_DRV_BASE + 192), gCpriTestMode);

    axc_data_init();
    return 0;
}


/**********************************************************************************************************************
*  function: fh_data_check
*  description: 
*  input : none
*  output: none
*  return: none
*  others: none
**********************************************************************************************************************/
void fh_data_check(uint32_t times)
{
    return;
}


/**********************************************************************************************************************
*  function: fh_test_case
*  description: 
*  input : none
*  output: none
*  return: none
*  others: none
**********************************************************************************************************************/
void fh_test_case()
{
	UCP_API_CPRI_CSU_START();
}


/**********************************************************************************************************************
*  function: fh_csu_test_init
*  description: 
*  input : none
*  output: none
*  return: none
*  others: none
**********************************************************************************************************************/
int32_t fh_csu_test_init(void)
{
    Phy_Timer_Csu_Config_Nr();
    return 0;
}


/**********************************************************************************************************************
*  function: fh_drv_init
*  description: 
*  input : none
*  output: none
*  return: none
*  others: none
**********************************************************************************************************************/
int32_t fh_drv_init(void)
{
    stFrontHaulDrvPara fhDrvPara;

    memset_ucp(&fhDrvPara, 0, sizeof(stFrontHaulDrvPara));

    fhDrvPara.protocolSel = PROTOCOL_CPRI;
    fhDrvPara.rateOption  = CPRI_OPTION_10;
    fhDrvPara.mapOption   = OTIC_MAP_8NR_8LTE;
    fronthaul_drv_cfg(&fhDrvPara);

    return 0;
}


